<?php
include_once '..\\authserv\\common_functions.php';
include_once "..\\local\\transaction.php";


$pending_release=false;

$settingobj			= new COM("FSCONFIG.Cfgmgr") or die("ppal_ipn.php FSCONFIG.Cfgmgr Object cannot be created!");
$receiver_email		= $settingobj->getKey( "ppal_business", "paypal");
$ppal_test			= $settingobj->getKey( "paypal_testing", "paypal");
$fsVer				= $settingobj->getKey( "versionDesc", "version");
$verNum				= explode(".", $fsVer);

if($settingobj->getKey( "ppal_pending_release", "paypal") == "yes")
	$pending_release = true;

$settingobj=null;

$myTxn = new transaction();

if(intval($verNum[0]) < 8)
{
	$myTxn->writeLog("..\\log\\txn.log", "Incorrect ppal_ipn.php");
	exit(0);
}

// Need https for sandbox. If using https, please put '/' at the end of the url
if ($ppal_test == 'true')
	$url = "https://www.sandbox.paypal.com/cgi-bin/webscr/";
else
	$url = "https://www.paypal.com/cgi-bin/webscr/";

//copy $_POST for validation
foreach ($_POST as $key => $val)
	$postfields[strtolower($key)] = $val;
    

$url_req = "cmd=_notify-validate&";
$url_req .= $myTxn->postfields_urlencode($_POST);

// workaround for https using curl
// * not include content length
//$header = Array("POST HTTP/1.0", "Content-Type: application/x-www-form-urlencoded");
//$result = $myTxn->postback_ssl($url, $header, $url_req, 120);
$result = $myTxn->postback_ssl_2($url, $url_req, 120);

if (!isset($_POST["custom"])) {
	$log = date('l dS \of F Y h:i:s A')." - undefine invoice number.\r\n\r\n";
	$myTxn->writeLog("..\\log\\txn.log", $log);
	die;
}

// running time (for calculate prorata use)
$current_time = time();

if (strcmp ($result, "VERIFIED") == 0)
{ 
  $valid_txn = true;

  $log = "";
  
  //20080709 fixed recurring payments for showing status "Failed" in the transaction log of credit cards even the payment is approved.
  //now only accept three type of transaction which are "cart", "web_accept" and "subscr_payment"
	if ( !isset($_POST["txn_type"])  ){
		$log .= date('l dS \of F Y h:i:s A')." - transaction type not found\r\n";
		$valid_txn = false;
	}else if (  strcmp($_POST["txn_type"], "cart")!=0 && strcmp($_POST["txn_type"], "web_accept")!=0
		&& strcmp($_POST["txn_type"], "subscr_payment")!=0  ){
		$log .= date('l dS \of F Y h:i:s A')." - mismatched transaction type\r\n";
		$valid_txn = false;
	}
  
  if ( isset($_POST["txn_id"]) && $myTxn->isexist_transaction("txn_id", $_POST["txn_id"]) == true ) {
    $log .= date('l dS \of F Y h:i:s A')." - Transaction has been processed\r\n";
    $valid_txn = false;
  }
	//20080725 direct payment checks the wrong reciever_email from the ipn.
	//It is now fixed by skipping the checking of receiver_email
	if (isset($_POST["txn_type"]) && strcmp($_POST["txn_type"], "cart")!=0
		&& isset($_POST["receiver_email"]) && strcmp ($_POST["receiver_email"], $receiver_email) != 0) {
		$log .= date('l dS \of F Y h:i:s A')." - Incorrect reciever_email\r\n";
		$valid_txn = false;
  }

  if (isset($_POST["mc_gross"]) && isset($_POST["mc_currency"]))
    if ($_POST["mc_gross"]!=$postfields['mc_gross'] && $_POST["mc_currency"]!=$postfields['mc_currency']) {
      $log .= date('l dS \of F Y h:i:s A')." - Incorrect mc_gross and mc_currency\r\n";
      $valid_txn = false;
    }

  if (isset($_POST["item_number"]) && isset($_POST["item_name"]))
    if ($_POST["item_number"]!=$postfields['item_number'] && $_POST["item_name"]!=$postfields['item_name']) {
      $log .= date('l dS \of F Y h:i:s A')." - Incorrect item_number and item_name\r\n";
      $valid_txn = false;
    }
	
	// 21-01-2010 get post time 
	if (isset($_POST["custom"])){
		list($invoice_no, $username, $plan, $post_time) = explode("|", $_POST["custom"]);
	}
  
  if ( $myTxn->isexist_transaction("invoice", $invoice_no) != true ) {
    $log .= date('l dS \of F Y h:i:s A')." - invoice number not found\r\n";
    $valid_txn = false;
  }
  
  if (isset($post_time) && $post_time >0){
	$withinDay = false;
	$curr_localtime  = localtime($current_time, true);
	$post_localtime  = localtime($post_time, true);
	// compare the running time within a day
	if ($curr_localtime['tm_year'] == $post_localtime['tm_year'] && $curr_localtime['tm_yday'] == $post_localtime['tm_yday']){ // compare year and Day of the year 
		$withinDay = true;
	}
	if ($withinDay == false) { // not at the same day
		$log .= date('l dS \of F Y h:i:s A')." - Transaction (between submit and notification) not at the same day, it will affect calculate price with prorata\r\n";
		$valid_txn = false;
	}
  }

  if ( $valid_txn == false ) {
    foreach ( $_POST as $key => $val )
      $log .= "$key = $val\r\n";
    $log .= "\r\n";
    $myTxn->writeLog("..\\log\\txn.log", $log);
  }
  
}
else
{ 
  $log = date('l dS \of F Y h:i:s A')." - Failed to Verify Transaction!\r\n";
    // 20081126 - Add debug print
    $log .= "result [".$result."]\r\n";
  foreach ( $_POST as $key => $val )
    $log .= "$key = $val\r\n";
  $log .= "\r\n";  

  $myTxn->writeLog("..\\log\\txn.log", $log);
  
  die;
}

if ($valid_txn == true)
{
  $txn_fields=array();

	// 20090708 - Add field type array
	$bFieldNumeric = array();

  if (isset($_POST["custom"]))
	list($invoice_no, $username, $plan, $post_time) = explode("|", $_POST["custom"]);
  
	if (isset($_POST["payment_status"])) {
		$txn_fields['pay_status'] = $_POST["payment_status"];
		$bFieldNumeric['pay_status'] = 0;
	}
  
	if (isset($_POST["pending_reason"])) {
		$txn_fields['pendreason'] = $_POST["pending_reason"];
		$bFieldNumeric['pendreason'] = 0;
	}
  
	if (isset($_POST["payment_date"])) {
		$txn_fields['pay_date'] = $_POST["payment_date"];
		$bFieldNumeric['pay_date'] = 0;
	}

	// 20090408 - Leave blank if status is pending and not treating pending as completed
	if (isset($_POST["txn_id"])) {
		if (strtolower($txn_fields['pay_status']) == 'pending' && $pending_release == FALSE) {
			$txn_fields['txn_id'] = '';
		} else {
			$txn_fields['txn_id'] = $_POST["txn_id"];
		}
		$bFieldNumeric['txn_id'] = 0;
	}
  
	if (isset($_POST["payment_type"])) {
		$txn_fields['pay_type'] = $_POST["payment_type"];
		$bFieldNumeric['pay_type'] = 0;
	}
  
	if (isset($_POST["first_name"])) {
		$txn_fields['first_name'] = $_POST["first_name"];
		$bFieldNumeric['first_name'] = 0;
	}
  
	if (isset($_POST["last_name"])) {
		$txn_fields['last_name'] = $_POST["last_name"];
		$bFieldNumeric['last_name'] = 0;
	}
  
	if (isset($_POST["payer_email"])) {
		$txn_fields['payeremail'] = $_POST["payer_email"];
		$bFieldNumeric['payeremail'] = 0;
	}
  
	if (isset($_POST["payer_id"])) {
		$txn_fields['payer_id'] = $_POST["payer_id"];
		$bFieldNumeric['payer_id'] = 0;
	}
  
	if (isset($_POST["txn_type"])) {
		$txn_fields['txn_type'] = $_POST["txn_type"];
		$bFieldNumeric['txn_type'] = 0;
	}
  
	if (isset($_POST["subscr_date"])) {
		$txn_fields['subscrdate'] = $_POST["subscr_date"];
		$bFieldNumeric['subscrdate'] = 0;
	}
  
	if (isset($_POST["subscr_id"])) {
		$txn_fields['subscr_id'] = $_POST["subscr_id"];
		$bFieldNumeric['subscr_id'] = 0;
	}

  //handle your own postfields
  
	// 20080724 - Added code to support PayPal Direct Payment
    // 20071115 - Handle tax and shipping postfields issue
    // 20071114 - Set error flag
    // 20070807 - Validate if transacted amount matches with the plan
    //update transaction
    $payErrFlag = 0;
    $pureGross = 0;
	if ( strcmp($_POST["txn_type"], "cart")==0 ){
		$item_field="item_name1";
	}else{
		$item_field="item_name";
	}
    if (count($txn_fields) > 0) {
		if (isset($_POST[$item_field]) && isset($_POST["mc_gross"])) {
		    if (isset($_POST["tax"]) && $_POST["tax"] > 0) {
				$pureGross = $_POST["mc_gross"] - $_POST["tax"];
		    } else {
				$pureGross = $_POST["mc_gross"];
		    }
		    if (isset($_POST["shipping"]) && $_POST["shipping"] > 0) {
				$pureGross = $pureGross - $_POST["shipping"];
		    }
			
			if (isset($post_time) && $post_time > 0){ // >0: using item attribute and set monthly pass
				$cart_item_arr = null;
				$cart_item_arr = $myTxn->get_cart_item_arr_by_desc($_POST[$item_field]);
				if($cart_item_arr!=null){
					$base_time = 0;
					$u_expire_month = 0;

					if ($username != ""){
						$u_expire_month = fs_expire_month_utime($username); // get user expire month (unix timestamp format)
					}

					if ( $current_time > $u_expire_month || $u_expire_month == false) // emonth eyear field is null or expired
						$base_time = $current_time;
					else
						$base_time = $u_expire_month;
						
					if ($cart_item_arr['useMethod'] == 1&& isset($cart_item_arr['item_attr']['topup']) && $cart_item_arr['item_attr']['topup'] >0){ // uisng item attribute and set monthly pass
						// calculate price with prorata
						$p_price = fs_cal_price_with_prorata($base_time, $cart_item_arr["amount"], $cart_item_arr["item_attr"]["topup"], 2);
						
						$pureGross = $pureGross + ($cart_item_arr["amount"] - $p_price);
					}
					else{
					}
				}
			}
			
		    $vRC = $myTxn->ValidateCart($_POST[$item_field], $pureGross);
		    if ($vRC == -1) {
				$txn_fields['pay_status'] = "Failed";
				$bFieldNumeric['pay_status'] = 0;
				$payErrFlag = -2;
		    } elseif ($vRC == -2) {
				$txn_fields['pay_status'] = "Failed";
				$bFieldNumeric['pay_status'] = 0;
				$payErrFlag = -3;
		    }
		} else {
		    $txn_fields['pay_status'] = "Failed";
			$bFieldNumeric['pay_status'] = 0;
		    $payErrFlag = -1;
		}
	//$log = "PayPal : ".date('l dS \of F Y h:i:s A')." - ".$_POST["item_name"]." ".$_POST["mc_gross"]." ".$txn_fields["pay_status"]."\r\n";
	//$myTxn->writeLog("..\\log\\txn.log", $log);
		$myTxn->update_transaction($invoice_no, $txn_fields, $bFieldNumeric);
    }

    // 20071116 - Enhance log messages
    // 20070807 - Add condition and log message
    //update user credit
    if (isset($_POST["payment_status"]) && isset($_POST["txn_id"])) {
	if (((strtolower($_POST["payment_status"]) == "completed" || (strtolower($_POST["payment_status"]) == "pending" && $pending_release==true))) && strtolower($txn_fields['pay_status']) != "failed") {
	
		if (!isset($plan) || $plan =='')
			$myTxn->update_usr_table_by_item_attr($username, $_POST[$item_field], $post_time);
		else
			$myTxn->update_usr_table($username, $plan);
			
	    $log = "PayPal : ".date('l dS \of F Y h:i:s A')." - $username account has been updated!\r\n";

	    // 20071114 - Print all postfields for debugging only
	    /*foreach ($_POST as $key => $val) {
		$log .= "$key = $val\r\n";
	    }*/
	} else {
	    if ($payErrFlag == -1) {
		$log = "PayPal : ".date('l dS \of F Y h:i:s A')." - Fail to update $username account due to insufficient payment information!\r\n";
	    } elseif ($payErrFlag == -2) {
		$log = "PayPal : ".date('l dS \of F Y h:i:s A')." - Fail to update $username account due to chosen shopping item does not exist!\r\n";
	    } elseif ($payErrFlag == -3) {
		$log = "PayPal : ".date('l dS \of F Y h:i:s A')." - Fail to update $username account due to payment amount mismatch!\r\n";
	    } else {
		$log = "PayPal : ".date('l dS \of F Y h:i:s A')." - Fail to update $username account!\r\n";
	    }

	    // 20071114 - Print all postfields for investigation
	    foreach ($_POST as $key => $val) {
		$log .= "$key = $val\r\n";
	    }
	}
	$log .= "\r\n";
	$myTxn->writeLog("..\\log\\txn.log", $log);      
    }	
}
?>
